"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BatchActionV1 = void 0;
const transaction_1 = require("./transaction");
class BatchActionV1 {
    constructor() {
        this.actions = [];
    }
    newOrderV1(market_id, params) {
        this.actions.push({
            action: 'NewOrder',
            params: {
                market_id,
                params: (0, transaction_1.prepareNewOrderV1)(params),
            },
        });
    }
    cancelOrdersV1(market_id, order_ids) {
        this.actions.push({
            action: 'CancelOrders',
            params: {
                market_id,
                order_ids,
            },
        });
    }
    cancelAllOrdersV1(market_id) {
        this.actions.push({
            action: 'CancelAllOrders',
            params: {
                market_id,
            },
        });
    }
    prepare() {
        return this.actions;
    }
}
exports.BatchActionV1 = BatchActionV1;
