"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Tonic = void 0;
const utils_1 = require("@tonic-foundation/utils");
const storage_1 = require("@tonic-foundation/storage");
const token_1 = require("@tonic-foundation/token");
const bn_js_1 = __importDefault(require("bn.js"));
const batch_1 = require("./batch");
const contract_1 = require("./contract");
const market_1 = require("./market");
const token_2 = require("./token");
const types_1 = require("./types");
const util_1 = require("./util");
const tonicTxn = __importStar(require("./transaction"));
const providers_1 = require("near-api-js/lib/providers");
/**
 * Tonic client. Expects that the Account parameter
 */
class Tonic {
    constructor(account, contractId) {
        this.account = account;
        this.contractId = contractId;
        this._contract = (0, contract_1.getContract)(account, contractId);
    }
    get contract() {
        return this._contract;
    }
    /**
     * This function calls a change method, returning both the return value of the
     * call and the execution outcome. Provide the `contractId` property to call a
     * different contract, defaults to the Tonic DEX.
     *
     * Many use cases need transaction/receipt IDs after calling a change
     * method, which makes the NEAR SDK's Contract class unsuitable.
     * https://github.com/near/near-api-js/blob/c84aef6cc18fe5ac1063411c95283ba3130fa656/src/contract.ts#L145
     */
    functionCallWithOutcome(params) {
        return __awaiter(this, void 0, void 0, function* () {
            const executionOutcome = yield this.account.functionCall(Object.assign({ contractId: this.contractId }, params));
            return {
                executionOutcome,
                response: (0, providers_1.getTransactionLastResult)(executionOutcome),
            };
        });
    }
    /**
     * Execute batch actions. See the example in the "examples" directory for more
     * information.
     */
    executeBatch(batch) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.functionCallWithOutcome(tonicTxn.batchV1(this.contractId, batch).toAccountFunctionCallParams());
        });
    }
    /**
     * Deposit NEAR for storage staking. We recommend depositing 0.1 NEAR at a
     * time to give users some room to place orders.
     *
     * Pass `amount` as a decimal amount of NEAR to deposit, eg, 0.1.
     *
     * Passing `registrationOnly` causes deposit in excess of the minimum required
     * balance to be refunded. The minimum balance is computed at runtime, so it's
     * recommended to pass at least 0.01 NEAR to avoid issues.
     *
     * The account to deposit for can be specified with `accountId`. Omit it to
     * deposit for the caller's account.
     */
    storageDeposit(params) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield (0, storage_1.storageDeposit)(this.account, this.contractId, params);
        });
    }
    /**
     * Create a market
     */
    createMarket(params) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.functionCallWithOutcome(tonicTxn
                .createMarketV1(this.contractId, params)
                .toAccountFunctionCallParams());
        });
    }
    /**
     * Place an order. This is a relatively low-level method that works with
     * lot-aware values. Client applications may use Market.placeOrder instead for
     * a higher-level interface.
     */
    placeOrder(market_id, order) {
        return __awaiter(this, void 0, void 0, function* () {
            const { response: r, executionOutcome } = yield this.functionCallWithOutcome(tonicTxn
                .placeOrderV1(this.contractId, market_id, order)
                .toAccountFunctionCallParams());
            return {
                response: {
                    id: r.id,
                    outcome: r.outcome,
                    open_quantity: new bn_js_1.default(r.open_quantity),
                    base_fill_quantity: new bn_js_1.default(r.base_fill_quantity),
                    quote_fill_quantity: new bn_js_1.default(r.quote_fill_quantity),
                    base_cancelled_quantity: new bn_js_1.default(r.base_cancelled_quantity),
                },
                executionOutcome,
            };
        });
    }
    /**
     * Cancel an order.
     */
    cancelOrder(market_id, order_id) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.functionCallWithOutcome(tonicTxn
                .cancelOrderV1(this.contractId, market_id, order_id)
                .toAccountFunctionCallParams());
        });
    }
    /**
     * Cancel multiple orders in a market. Use Tonic.executeBatch
     * to cancel orders in multiple markets.
     */
    cancelOrders(marketId, orderIds) {
        return __awaiter(this, void 0, void 0, function* () {
            const batch = new batch_1.BatchActionV1();
            batch.cancelOrdersV1(marketId, orderIds);
            return yield this.executeBatch(batch);
        });
    }
    /**
     * Cancel all orders in a market.
     */
    cancelAllOrders(market_id) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.functionCallWithOutcome(tonicTxn
                .cancelAllOrdersV1(this.contractId, market_id)
                .toAccountFunctionCallParams());
        });
    }
    /**
     * Deposit NEP 141 tokens or native NEAR. For native NEAR, the `tokenId` must
     * be 'NEAR'.
     *
     * The amount must be decimal-aware, eg, to deposit 1 NEAR (24 decimals), use
     *
     * ```
     * import { decimalToBn } from '@tonic-foundation/utils';
     * // Deposit 1 NEAR
     * tonic.deposit('NEAR', decimalToBn(1, 24))
     * // Deposit 1 USDC
     * tonic.deposit('usdc.example.testnet', decimalToBn(1, 6))
     * ```
     */
    deposit(tokenId, amount) {
        return __awaiter(this, void 0, void 0, function* () {
            if (tokenId.toUpperCase() === 'NEAR') {
                return yield this.depositNear(amount);
            }
            else {
                return this.depositFt(tokenId, amount, '');
            }
        });
    }
    /**
     * Deposit NEP-141 token.
     */
    depositFt(tokenId, amount, msg) {
        return __awaiter(this, void 0, void 0, function* () {
            const formattedMsg = typeof msg === 'string' ? msg : JSON.stringify(msg);
            return yield (0, token_1.ftTransferCall)(this.account, tokenId, {
                receiverId: this.contractId,
                amount,
                msg: formattedMsg,
            });
        });
    }
    /**
     * Deposit native NEAR.
     */
    depositNear(amount) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.functionCallWithOutcome(tonicTxn
                .depositNearV1(this.contractId, amount)
                .toAccountFunctionCallParams());
        });
    }
    /**
     * Return function call parameters for a swap from an Fungible Token.
     *
     * Note: because swapping does not use the user's exchange balance, the caller
     * is responsible for checking that the user has a storage deposit in the
     * output token. Failed swaps due to missing storage deposit will not refund
     * the user.
     *
     * @deprecated use `getSwapParams` and request a signature from the
     * authenticated wallet to take advantage of multi-swap feature
     */
    swap(tokenId, amount, swaps) {
        return __awaiter(this, void 0, void 0, function* () {
            if (tokenId.toUpperCase() === 'NEAR') {
                return yield this.swapNear(amount, swaps);
            }
            else {
                return yield this.depositFt(tokenId, amount, {
                    action: 'Swap',
                    params: swaps.map((s) => {
                        var _a;
                        return (Object.assign(Object.assign({}, s), { min_output_token: (_a = s.min_output_token) === null || _a === void 0 ? void 0 : _a.toString() }));
                    }),
                });
            }
        });
    }
    /**
     * Return function call parameters for a swap from native NEAR.
     *
     * Note: because swapping does not use the user's exchange balance, the caller
     * is responsible for checking that the user has a storage deposit in the
     * output token. Failed swaps due to missing storage deposit will not refund
     * the user.
     *
     * @deprecated use `getSwapParams` and request a signature from the
     * authenticated wallet to take advantage of multi-swap feature
     */
    swapNear(amount, swaps) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.functionCallWithOutcome({
                methodName: 'swap_near',
                args: {
                    swaps: swaps.map((s) => {
                        var _a;
                        return (Object.assign(Object.assign({}, s), { min_output_token: (_a = s.min_output_token) === null || _a === void 0 ? void 0 : _a.toString() }));
                    }),
                },
                attachedDeposit: amount,
                gas: utils_1.MAX_GAS,
            });
        });
    }
    /**
     * Withdraw NEP 141 tokens or native NEAR. For native NEAR, the `tokenId` must
     * be 'NEAR'.
     *
     * The amount must be decimal-aware, eg,
     *
     * ```
     * import { decimalToBn } from '@tonic-foundation/utils';
     * // Withdraw 1 NEAR
     * tonic.withdraw('NEAR', decimalToBn(1, 24))
     * // Withdraw 1 USDC
     * tonic.withdraw('usdc.example.testnet', decimalToBn(1, 6))
     * ```
     */
    withdraw(tokenId, amount) {
        return __awaiter(this, void 0, void 0, function* () {
            if (tokenId.toUpperCase() === 'NEAR') {
                return yield this.withdrawNear(amount);
            }
            else {
                return this.withdrawFt(tokenId, amount);
            }
        });
    }
    withdrawFt(tokenId, amount) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.functionCallWithOutcome(tonicTxn
                .withdrawFtV1(this.contractId, tokenId, amount)
                .toAccountFunctionCallParams());
        });
    }
    withdrawNear(amount) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.functionCallWithOutcome(tonicTxn
                .withdrawNearV1(this.contractId, amount)
                .toAccountFunctionCallParams());
        });
    }
    /**
     * Get the orderbook. Orders are returned with decimals (eg, 1 USDC is
     * returned as 1000000). The format of each order is [price, open quantity].
     *
     * @param market_id
     * @param depth Number of price levels to fetch, default 12
     * @returns
     */
    getOrderbook(market_id, depth = 12) {
        return __awaiter(this, void 0, void 0, function* () {
            const view = yield this._contract.get_orderbook({
                market_id,
                depth,
            });
            const { bids, asks } = (0, types_1.toOrderBook)(view);
            return {
                bids: (0, util_1.groupOrdersByPriceLevel)(bids),
                asks: (0, util_1.groupOrdersByPriceLevel)(asks),
            };
        });
    }
    getOpenOrders(market_id) {
        return __awaiter(this, void 0, void 0, function* () {
            const raw = yield this._contract.get_open_orders({
                market_id,
                account_id: this.account.accountId,
            });
            return raw.map(types_1.toOpenLimitOrder);
        });
    }
    getOrder(market_id, order_id) {
        return __awaiter(this, void 0, void 0, function* () {
            const raw = yield this._contract.get_order({
                market_id,
                order_id,
            });
            if (!raw) {
                return null;
            }
            return (0, types_1.toOpenLimitOrder)(raw);
        });
    }
    getMarket(marketId) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield market_1.Market.load(this, marketId, this.contractId);
        });
    }
    /**
     * List markets in order of creation.
     */
    listMarkets(offset = 0, limit = 100) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.contract.list_markets({ from_index: offset, limit });
        });
    }
    /**
     * Return available exchange balances with decimals as a map of { tokenId =>
     * balance }. "Available balance" is balance not currently locked in an open
     * order. For example, an account with 1 USDC available would see
     *
     * ```
     * await tonic.getBalances() // { usdc.example.testnet: BN<1000000> }
     * ```
     */
    getBalances() {
        return __awaiter(this, void 0, void 0, function* () {
            const ret = {};
            const rawBalances = yield this._contract.get_balances({
                account_id: this.account.accountId,
            });
            rawBalances.forEach(([token_id, amount]) => {
                ret[(0, token_2.extractTokenContractId)(token_id)] = new bn_js_1.default(amount);
            });
            return ret;
        });
    }
}
exports.Tonic = Tonic;
