import BN from 'bn.js';
import { FunctionCallOptions as NearApiJsFunctionCall } from 'near-api-js/lib/account';
import { PrepareBatch } from './batch';
import { NewOrderParamsV1 } from './types/v1';
import { PartialBy } from './util';
import { StandardNearFunctionCall } from '@tonic-foundation/transaction/lib/shim';
import { MarketId } from './types';
export declare function prepareNewOrderV1(params: NewOrderParamsV1): NewOrderParamsV1;
export declare type ImplicitContractFunctionCallParams = PartialBy<NearApiJsFunctionCall, 'contractId'>;
export declare function batchV1(contractId: string, batch: PrepareBatch): StandardNearFunctionCall;
export declare function createMarketV1(contractId: string, params: {
    baseTokenId: string;
    quoteTokenId: string;
    baseTokenLotSize: string;
    quoteTokenLotSize: string;
    takerFeeBaseRate: number;
    makerRebateBaseRate: number;
}): StandardNearFunctionCall;
export declare function placeOrderV1(contractId: string, market_id: MarketId, order: NewOrderParamsV1): StandardNearFunctionCall;
export declare function cancelOrderV1(contractId: string, market_id: string, order_id: string): StandardNearFunctionCall;
export declare function cancelAllOrdersV1(contractId: string, market_id: string): StandardNearFunctionCall;
export declare function withdrawNearV1(contractId: string, amount: BN): StandardNearFunctionCall;
export declare function withdrawFtV1(contractId: string, tokenId: string, amount: BN): StandardNearFunctionCall;
export declare function withdrawV1(contractId: string, tokenId: string, amount: BN): StandardNearFunctionCall;
export declare function depositNearV1(contractId: string, amount: BN): StandardNearFunctionCall;
